function MethodBuilder(ApplicationContext, $rootScope) {

	var context = {
		ctx: ApplicationContext
	};

	var flowControl = {
		"string": function(code, args) {
			return args.event.code ? buildEvent(args) : null;
		},

		"undefined": function(code, args) {
			if (args.event && args.event.unsecureCode) {
				/*jslint evil: true */
				return new Function(["args"], "var ctx = this.ctx;" + args.event.unsecureCode).bind(context);
			}
			return null;
		},

		"function": function(code) {
			return code;
		}

	};

	this.build = function(code, args) {
		var chooseFlow = typeof(code);
		return flowControl[chooseFlow](code, args);
	};

	function buildEvent(args) {
		return function() {
			ApplicationContext.args = arguments[0];
			var returnedValue = $rootScope.$eval(args.event.code, ApplicationContext);
			delete ApplicationContext.args;
			return returnedValue;
		};
	}

	function getOwner(owner) {
		if (!owner) {
			throw new Error("No controller found!");
		}
		return owner.controller ? owner.controller : getOwner(owner.getParent());
	}
}